# Get Pool By Address

We can apply filters on any field of a Raydium account. If we want to fetch a pool by its address (public key), then we need to apply where filter on its <mark style="color:yellow;">pubKey</mark>.

You can directly copy paste this code on <mark style="color:yellow;">replit</mark> and see it in action.

#### Fetch parsed pool info

{% tabs %}
{% tab title="Code Snippet" %}

```typescript
import { gql, GraphQLClient } from "graphql-request";

const endpoint = `https://programs.shyft.to/v0/graphql/?api_key=YOUR-KEY`;

const graphQLClient = new GraphQLClient(endpoint, {
  method: `POST`,
  jsonSerializer: {
    parse: JSON.parse,
    stringify: JSON.stringify,
  },
});

function queryLpByAddress(address:string) {
  // You can cherry pick what fields you want
  const query = gql`
    query MyQuery($where: Raydium_LiquidityPoolv4_bool_exp) {
  Raydium_LiquidityPoolv4(
    where: $where
  ) {
    amountWaveRatio
    baseDecimal
    baseLotSize
    baseMint
    baseNeedTakePnl
    baseTotalPnl
    baseVault
    depth
    lpMint
    lpReserve
    lpVault
    marketId
    marketProgramId
    maxOrder
    maxPriceMultiplier
    minPriceMultiplier
    minSeparateDenominator
    minSeparateNumerator
    minSize
    nonce
    openOrders
    orderbookToInitTime
    owner
    pnlDenominator
    pnlNumerator
    poolOpenTime
    punishCoinAmount
    punishPcAmount
    quoteDecimal
    quoteLotSize
    quoteMint
    quoteNeedTakePnl
    quoteTotalPnl
    quoteVault
    resetFlag
    state
    status
    swapBase2QuoteFee
    swapBaseInAmount
    swapBaseOutAmount
    swapFeeDenominator
    swapFeeNumerator
    swapQuote2BaseFee
    swapQuoteInAmount
    swapQuoteOutAmount
    systemDecimalValue
    targetOrders
    tradeFeeDenominator
    tradeFeeNumerator
    volMaxCutRatio
    withdrawQueue
    pubkey
  }
}`;

  const variables = {
    where: {
      pubkey: {
        _eq: address,
      },
    },
  };

  graphQLClient.request(query, variables).then(console.log);
}

//This is bonk-usdc pool addres
queryLpByAddress('Dwq4PxyBQ8dHPmP5u5H7bHsjHp46StGtkSy2gEVedDm');
```

{% endtab %}

{% tab title="Response" %}

```json
{
  "data": {
    "Raydium_LiquidityPoolv4": [
      {
        "_updatedAt": "2024-02-22T06:36:45.458",
        "amountWaveRatio": 0,
        "baseDecimal": 5,
        "baseLotSize": 10000,
        "baseMint": "DezXAZ8z7PnrnRJjz3wXBoRgixCa6xjnB7YaB1pPB263",
        "baseNeedTakePnl": 12694564693,
        "baseTotalPnl": 39633555332836,
        "baseVault": "F2ZFU1hdDwAmDPbWuKX1qohAV7hBMj2enWZtLfZApx97",
        "depth": 3,
        "lpMint": "BpqWJpczgzWJzcgWQMtrXEJUvrygt1rzvNBgXtDdsXQQ",
        "lpReserve": 46340706009,
        "lpVault": "11111111111111111111111111111111",
        "marketId": "29H6FoFb67BsEWxhBjKPArN7qNYaDUpQovVJRccZvEZL",
        "marketProgramId": "srmqPvymJeFKQ4zGQed1GFppgkRHL9kaELCbyksJtPX",
        "maxOrder": 7,
        "maxPriceMultiplier": 1000000000,
        "minPriceMultiplier": 1,
        "minSeparateDenominator": 10000,
        "minSeparateNumerator": 5,
        "minSize": 100000000,
        "nonce": 254,
        "openOrders": "ErMxRaZC5WTELmWTi9ZiW8UNrvaYWmxADgJnqMGmRysK",
        "orderbookToInitTime": 0,
        "owner": "GThUX1Atko4tqhN2NaiTazWSeFWMuiUvfFnyJyUghFMJ",
        "pnlDenominator": 100,
        "pnlNumerator": 12,
        "poolOpenTime": 0,
        "punishCoinAmount": 0,
        "punishPcAmount": 0,
        "quoteDecimal": 9,
        "quoteLotSize": 100000,
        "quoteMint": "H1G6sZ1WDoMmMCFqBKAbg9gkQPCo1sKQtaJWz9dHmqZr",
        "quoteNeedTakePnl": 313216692,
        "quoteTotalPnl": 210843077242,
        "quoteVault": "Chbwh4TAsfxLDYEdjkyvSFbDr8esqt71ExKfdLeQubTp",
        "resetFlag": 0,
        "state": 2,
        "status": 6,
        "swapBase2QuoteFee": 206613319069,
        "swapBaseInAmount": 15725949574164032,
        "swapBaseOutAmount": 15691685262238296,
        "swapFeeDenominator": 10000,
        "swapFeeNumerator": 25,
        "swapQuote2BaseFee": 39314873950670,
        "swapQuoteInAmount": 82645318416425,
        "swapQuoteOutAmount": 81305093032731,
        "systemDecimalValue": 1000000000,
        "targetOrders": "FiwpFcuoNhbaZTvuf2xYgmDQa2XExjpBBPGSSbgYYUKA",
        "tradeFeeDenominator": 10000,
        "tradeFeeNumerator": 25,
        "volMaxCutRatio": 500,
        "withdrawQueue": "11111111111111111111111111111111",
        "pubkey": "Dwq4PxyBQ8dHPmP5u5H7bHsjHp46StGtkSy2gEVedDm"
      }
    ]
  }
}
```

{% endtab %}
{% endtabs %}

#### Get pools liquidity detail

Once you have a pool's parsed info, you need to understand how to interpret the returned data and make sense out of it. Let us see how we can get pools liquidity details.

{% hint style="info" %}
You can also check pool's LP burnt percentage [with this example](/solana-indexers/case-studies/raydium/get-pool-burn-percentage.md).
{% endhint %}

{% code overflow="wrap" fullWidth="false" %}

```typescript
import { Connection, PublicKey } from "@solana/web3.js";
import { OpenOrders } from "@project-serum/serum";
import { gql, GraphQLClient } from "graphql-request";

const graphQLEndpoint = `https://programs.shyft.to/v0/graphql/?api_key=YOUR-KEY`;
const rpcEndpoint = `https://rpc.shyft.to/?api_key=YOUR-KEY`;

const graphQLClient = new GraphQLClient(graphQLEndpoint, {
  method: `POST`,
  jsonSerializer: {
    parse: JSON.parse,
    stringify: JSON.stringify,
  },
});

async function queryLpByAddress(address:string) {
  // We only fetch fields necessary for us
  const query = gql`
    query MyQuery($where: Raydium_LiquidityPoolv4_bool_exp) {
  Raydium_LiquidityPoolv4(
    where: {pubkey: {_eq: ${JSON.stringify(address)}}}
  ) {
    baseDecimal
    baseMint
    baseNeedTakePnl
    baseVault
    marketId
    marketProgramId
    openOrders
    quoteDecimal
    quoteMint
    quoteNeedTakePnl
    quoteVault
  }
}`;

  return await graphQLClient.request(query);
}

//We have to check how much tokens are present in openbook market as well
export async function parsePoolInfo(poolInfo) {
  const OPENBOOK_PROGRAM_ID = new PublicKey(
    "srmqPvymJeFKQ4zGQed1GFppgkRHL9kaELCbyksJtPX"
  );

  //to load openOorders from openbook
  const connection = new Connection(rpcEndpoint, "confirmed");

  console.time('load')
  const openOrders = await OpenOrders.load(
    connection,
    new PublicKey(poolInfo.openOrders),
    OPENBOOK_PROGRAM_ID
  );
  console.timeEnd('load')

  const baseDecimal = 10 ** poolInfo.baseDecimal; // e.g. 10 ^ 6
  const quoteDecimal = 10 ** poolInfo.quoteDecimal;

  const baseTokenAmount = await connection.getTokenAccountBalance(
    new PublicKey(poolInfo.baseVault)
  );
  const quoteTokenAmount = await connection.getTokenAccountBalance(
    new PublicKey(poolInfo.quoteVault)
  );

  const basePnl = poolInfo.baseNeedTakePnl / baseDecimal;
  const quotePnl = poolInfo.quoteNeedTakePnl / quoteDecimal;

  const openOrdersBaseTokenTotal =
    openOrders.baseTokenTotal / baseDecimal;
  const openOrdersQuoteTokenTotal =
    openOrders.quoteTokenTotal / quoteDecimal;

  const base =
    (baseTokenAmount.value?.uiAmount || 0) + openOrdersBaseTokenTotal - basePnl;
  const quote =
    (quoteTokenAmount.value?.uiAmount || 0) +
    openOrdersQuoteTokenTotal -
    quotePnl;

  console.log(
    "Pool info:",
    "\n pool total base " + base,
    "\n pool total quote " + quote,

    "\n base vault balance " + baseTokenAmount.value.uiAmount,
    "\n quote vault balance " + quoteTokenAmount.value.uiAmount,

    "\n base tokens in openorders " + openOrdersBaseTokenTotal,
    "\n quote tokens in openorders  " + openOrdersQuoteTokenTotal,
  );
}

//This is bonk-usdc pool addres
const poolInfo = await queryLpByAddress('DP2QV9nFwehHCXvKRsCn21g1UbVPctfHXSNrQXK24K9D');
console.log(poolInfo)

await parsePoolInfo(poolInfo.Raydium_LiquidityPoolv4[0])
```

{% endcode %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.shyft.to/solana-indexers/case-studies/raydium/get-pool-by-address.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
